%define anolis_release 3
%global with_pkg_config %(pkg-config --version >/dev/null 2>&1 && echo -n "1" || echo -n "0")

%global ibus_api_version 1.0
%global pkgcache /var/cache/%name

# for bytecompile in %%{_datadir}/ibus/setup
%global __python %{__python3}

%global emoji_enabled 0
%global tests_enabled 0

%bcond_without gtk4

%if %with_pkg_config
%{!?gtk2_binary_version: %global gtk2_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-2.0)}
%{!?gtk3_binary_version: %global gtk3_binary_version %(pkg-config  --variable=gtk_binary_version gtk+-3.0)}
%if %{with gtk4}
%{!?gtk4_binary_version: %global gtk4_binary_version %(pkg-config  --variable=gtk_binary_version gtk4)}
%else
%{!?gtk4_binary_version: %global gtk4_binary_version ?.?.?}
%endif
%global glib_ver %([ -a %{_libdir}/pkgconfig/glib-2.0.pc ] && pkg-config --modversion glib-2.0 | cut -d. -f 1,2 || echo -n "999")
%else
%{!?gtk2_binary_version: %global gtk2_binary_version ?.?.?}
%{!?gtk3_binary_version: %global gtk3_binary_version ?.?.?}
%{!?gtk4_binary_version: %global gtk4_binary_version ?.?.?}
%global glib_ver 0
%endif

%global dbus_python_version 0.83.0

Name:           ibus
Version:        1.5.28
Release:        %{anolis_release}%{?dist}
Summary:        Intelligent Input Bus for Linux OS
License:        LGPLv2+
URL:            https://github.com/ibus/%name/wiki
Source0:        https://github.com/ibus/%{name}/releases/download/%{version}/%{name}-%{version}.tar.gz
Source1:        %{name}-xinput
Source2:        %{name}.conf.5
# Under testing #1349148 #1385349 #1350291 #1406699 #1432252 #1601577
Patch1:         %{name}-1385349-segv-bus-proxy.patch

BuildRequires:  gettext-devel
BuildRequires:  libtool
# for gtkdoc-fixxref
BuildRequires:  glib2-doc
BuildRequires:  gtk2-devel
BuildRequires:  gtk3-devel
%if %{with gtk4}
BuildRequires:  gtk4-devel
%endif
BuildRequires:  dbus-glib-devel
BuildRequires:  dbus-python-devel >= %{dbus_python_version}
BuildRequires:  gtk-doc
BuildRequires:  dconf-devel
BuildRequires:  dbus-x11
BuildRequires:  python3-devel
BuildRequires:  python3-gobject
BuildRequires:  git
BuildRequires:  vala
BuildRequires:  iso-codes-devel
BuildRequires:  libnotify-devel
BuildRequires:  wayland-devel
%if %{emoji_enabled}
BuildRequires:  cldr-emoji-annotation
BuildRequires:  unicode-emoji
%endif
BuildRequires:  unicode-ucd
BuildRequires:  systemd
# for ibus-keypress
BuildRequires:  libXtst-devel

Requires:       %{name}-libs   = %{version}-%{release}
Requires:      (%{name}-gtk2   = %{version}-%{release} if gtk2)
Requires:       %{name}-gtk3   = %{version}-%{release}
Requires:       %{name}-setup          = %{version}-%{release}

Requires:       iso-codes
Requires:       dconf
Requires:       python3-gobject
%{?__python3:Requires: %{__python3}}
Requires:       xorg-x11-xinit
Requires:       setxkbmap

Requires:               dconf
Requires(postun):       dconf
Requires(posttrans):    dconf

Requires(post):         %{_sbindir}/alternatives
Requires(postun):       %{_sbindir}/alternatives

%global _xinputconf %{_sysconfdir}/X11/xinit/xinput.d/ibus.conf

%description
IBus means Intelligent Input Bus. It is an input framework for Linux OS.

%package libs
Summary:        IBus libraries

Requires:       dbus >= 1.2.4
Requires:       glib2 >= %{glib_ver}
Requires:       gobject-introspection

%description libs
This package contains the libraries for IBus

%package gtk2
Summary:        IBus IM module for GTK2
Requires:       %{name}-libs   = %{version}-%{release}
Requires:       glib2 >= %{glib_ver}
Provides:       ibus-gtk = %{version}-%{release}
Obsoletes:      ibus-gtk < %{version}-%{release}

%description gtk2
This package contains IBus IM module for GTK2

%package gtk3
Summary:        IBus IM module for GTK3
Requires:       %{name}-libs   = %{version}-%{release}
Requires:       glib2 >= %{glib_ver}

%description gtk3
This package contains IBus IM module for GTK3

%if %{with gtk4}
%package gtk4
Summary:        IBus IM module for GTK4
Requires:       %{name}-libs   = %{version}-%{release}
Requires:       glib2 >= %{glib_ver}

%description gtk4
This package contains IBus IM module for GTK4
%endif

%package setup
Summary:        IBus setup utility
Requires:       %{name} = %{version}-%{release}
%{?__python3:Requires: %{__python3}}
Requires:       python3-gobject
BuildRequires:  gobject-introspection-devel
BuildRequires:  pygobject3-devel
BuildRequires:  make
BuildArch:      noarch

%description setup
This is a setup utility for IBus.

%package wayland
Summary:        IBus IM module for Wayland
Requires:       %{name}-libs   = %{version}-%{release}

%description wayland
This package contains IBus IM module for Wayland

%package devel
Summary:        Development tools for ibus
Requires:       %{name}-libs   = %{version}-%{release}

%description devel
The ibus-devel package contains the header files and developer
docs for ibus.

%package devel-docs
Summary:        Developer documents for IBus
BuildArch:      noarch

%description devel-docs
The ibus-devel-docs package contains developer documentation for IBus

%if %{tests_enabled}
%package desktop-testing
Summary:        Wrapper of InstalledTests Runner for IBus
Requires:       %{name} = %{version}-%{release}
BuildRequires:  gnome-shell-extension-no-overview
Requires:       gnome-shell-extension-no-overview
BuildArch:      noarch

%description desktop-testing
GNOME desktop testing runner implements the InstalledTests specification
and IBus also needs focus events to enable input contexts on text widgets.
The wrapper script runs gnome-session for the focus events and GNOME
desktop testing runner internally.

%package  tests
Summary:        Tests for the %{name} package
Requires:       %{name} = %{version}-%{release}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.
%endif

%prep
%autosetup -p1

%build
autoreconf -f -i -v
%configure \
    --disable-static \
    --enable-gtk2 \
    --enable-gtk3 \
%if %{with gtk4}
    --enable-gtk4 \
%endif
    --enable-xim \
    --enable-gtk-doc \
    --enable-surrounding-text \
    --with-python=python3 \
    --disable-python2 \
    --enable-wayland \
    --enable-introspection \
%if %{tests_enabled}
    --enable-install-tests \
%endif
%if !%{emoji_enabled}
    --disable-emoji-dict \
%endif
    %{nil}

%make_build

%install
%make_install

# install man page
install -pm 644 -D %{SOURCE2} %{buildroot}%{_mandir}/man5/ibus.conf.5

# install xinput config file
install -pm 644 -D %{SOURCE1} %{buildroot}%{_xinputconf}

install -m 755 -d %{buildroot}%pkgcache/bus

# install .desktop files
echo "NoDisplay=true" >> %{buildroot}%{_datadir}/applications/org.freedesktop.IBus.Setup.desktop

HAS_PREFIX=$(grep prefix %{buildroot}%{_bindir}/ibus-setup | wc -l)
[ x"$HAS_PREFIX" == x1 ] && \
  sed -i -e '/prefix/d' %{buildroot}%{_bindir}/ibus-setup

# FIXME: no version number
%find_lang %{name}10

%check
%make_build check \
    DISABLE_GUI_TESTS="ibus-compose ibus-keypress test-stress xkb-latin-layouts" \
    %{nil}

%post
%{_sbindir}/alternatives --install %{_sysconfdir}/X11/xinit/xinputrc xinputrc %{_xinputconf} 83 || :

%postun
if [ "$1" -eq 0 ]; then
  %{_sbindir}/alternatives --remove xinputrc %{_xinputconf} || :
  # if alternative was set to manual, reset to auto
  [ -L %{_sysconfdir}/alternatives/xinputrc -a "`readlink %{_sysconfdir}/alternatives/xinputrc`" = "%{_xinputconf}" ] && %{_sbindir}/alternatives --auto xinputrc || :

  # 'dconf update' sometimes does not update the db...
  dconf update || :
  [ -f %{_sysconfdir}/dconf/db/ibus ] && \
      rm %{_sysconfdir}/dconf/db/ibus || :
fi

%posttrans
dconf update || :

%transfiletriggerin -- %{_datadir}/ibus/component
[ -x %{_bindir}/ibus ] && \
  %{_bindir}/ibus write-cache --system &>/dev/null || :

%transfiletriggerpostun -- %{_datadir}/ibus/component
[ -x %{_bindir}/ibus ] && \
  %{_bindir}/ibus write-cache --system &>/dev/null || :

%files -f %{name}10.lang
%doc AUTHORS COPYING README
%dir %{_datadir}/ibus/
%{_bindir}/ibus
%{_bindir}/ibus-daemon
%if %{emoji_enabled}
%{_datadir}/applications/org.freedesktop.IBus.Panel.Emojier.desktop
%{_datadir}/applications/org.freedesktop.IBus.Panel.Extension.Gtk3.desktop
%{_mandir}/man7/ibus-emoji.7.*
%{_libexecdir}/ibus-extension-gtk3
%{_libexecdir}/ibus-ui-emojier
%endif
%{_datadir}/bash-completion/completions/ibus.bash
%{_datadir}/dbus-1/services/*.service
%{_datadir}/GConf/gsettings/*
%{_datadir}/glib-2.0/schemas/*.xml
%{_datadir}/ibus/component
%{_datadir}/ibus/dicts
%dir %{_datadir}/ibus/engine
%{_datadir}/ibus/keymaps
%{_datadir}/icons/hicolor/*/apps/*
%{_mandir}/man1/ibus.1.*
%{_mandir}/man1/ibus-daemon.1.*
%{_mandir}/man5/00-upstream-settings.5.*
%{_mandir}/man5/ibus.5.*
%{_mandir}/man5/ibus.conf.5.*
%{_libexecdir}/ibus-engine-simple
%{_libexecdir}/ibus-dconf
%{_libexecdir}/ibus-portal
%{_libexecdir}/ibus-ui-gtk3
%{_libexecdir}/ibus-x11
%{_sysconfdir}/dconf/db/ibus.d
%{_sysconfdir}/dconf/profile/ibus
%dir %{_sysconfdir}/xdg/Xwayland-session.d
%{_sysconfdir}/xdg/Xwayland-session.d/10-ibus-x11
%{_prefix}/lib/systemd/user/gnome-session.target.wants/*.service
%{_prefix}/lib/systemd/user/org.freedesktop.IBus.session.*.service
%python3_sitearch/gi/overrides/__pycache__/*.py*
%python3_sitearch/gi/overrides/IBus.py
# ibus owns xinput.d because gnome does not like to depend on imsettings.
%dir %{_sysconfdir}/X11/xinit/xinput.d
# Do not use %%config(noreplace) to always get the new keywords in _xinputconf
# For user customization, $HOME/.xinputrc can be used instead.
%config %{_xinputconf}
%verify(not mtime) %dir %pkgcache
%verify(not mtime) %dir %pkgcache/bus
# 'ibus write-cache --system' updates the system cache.
%ghost %pkgcache/bus/registry

%files libs
%{_libdir}/libibus-*%{ibus_api_version}.so.*
%dir %{_libdir}/girepository-1.0
%{_libdir}/girepository-1.0/IBus*-1.0.typelib

%files gtk2
%{_libdir}/gtk-2.0/%{gtk2_binary_version}/immodules/im-ibus.so

%files gtk3
%{_libdir}/gtk-3.0/%{gtk3_binary_version}/immodules/im-ibus.so

%if %{with gtk4}
%files gtk4
%{_libdir}/gtk-4.0/%{gtk4_binary_version}/immodules/libim-ibus.so
%endif

# The setup package won't include icon files so that
# gtk-update-icon-cache is executed in the main package only one time.
%files setup
%{_bindir}/ibus-setup
%{_datadir}/applications/org.freedesktop.IBus.Setup.desktop
%{_datadir}/ibus/setup
%{_mandir}/man1/ibus-setup.1.*

%files wayland
%{_libexecdir}/ibus-wayland

%files devel
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_datadir}/gettext/its/ibus.*
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/IBus*-1.0.gir
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/ibus-*1.0.vapi
%{_datadir}/vala/vapi/ibus-*1.0.deps

%files devel-docs
%{_datadir}/gtk-doc/html/*

%if %{tests_enabled}
%files desktop-testing
%{_bindir}/ibus-desktop-testing-runner
%{_datadir}/ibus/tests
%{_libexecdir}/ibus-desktop-testing-autostart

%files tests
%dir %{_libexecdir}/installed-tests
%{_libexecdir}/installed-tests/ibus
%dir %{_datadir}/installed-tests
%{_datadir}/installed-tests/ibus
%endif

%changelog
* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 1.5.28-3
- Rebuild with python3.11

* Mon Mar 27 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 1.5.28-2
- Add switch for tests and emoji

* Tue Feb 21 2023 Funda Wang <fundawang@yeah.net> - 1.5.28-1
- New version 1.5.28

* Sat Nov 12 2022 Funda Wang <fundawang@yeah.net> - 1.5.27-1
- New version 1.5.27

* Tue Apr 12 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.5.25-1
- init from upstream
